<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Contrasenya</title>
</head>
<body>
    <script>
        MainFunction();

        function MainFunction() {
            var pwd = prompt("Enter password");
            Check(pwd);
        }

        function NumChar(pwd, minChar, maxChar) {
            if (pwd.length <= 8 || pwd.length >= 20) {
                return true;
            } else {
                return false;
            }
        }

        function TypeChar(pwd, minMinus, minMayus, minDigits) {
            var numMinus = 0;
            var numMayus = 0;
            var numDigits = 0;
            for (let index = 0; index < pwd.length; index++) {
                switch (pwd[index]) { //
                    case pwd[index] >= 97 && pwd[index] <= 122:
                        minMinus++;
                    break;
                    case pwd[index] >= 65 && pwd[index] <= 90:
                        minMayus++;
                        break;
                    case pwd[index] >= 49 && pwd[index] <= 57:
                        numDigits++;
                        break;
                }
            }
            if (numMinus >= 3 || numMayus >= 1 || numDigits >= 2) { // En el doc no s'especifica que els minims han d'estar incluits
                return false;
            }else{
                return true;
            }
        }
        
        function NoRep(pwd) {
            for (let index = 2; index < pwd.length; index++){
                if (pwd[index] == pwd[index-1] && pwd[index] == pwd[index-2]) {
                    return false;
                }else{
                    return true;
                }
            }
        }

        function Check(pwd) {
            var minChar = 8;
            var maxChar = 20;
            var minMinus = 3;
            var minMayus = 1;
            var minDigits = 2;
            var errorNumChar = "";  //
            var errorTypeChar = ""; // No s'especifica el nom de les variables, per tant entenc que cada nom correspon als diferents errors 
            var errorNoRep = "";    //

            if (NumChar(pwd, minChar, maxChar)) {
                errorNumChar = "ERROR: invalid password - it must have between 8 and 20 characters\n";
                console.log(errorNumChar);
            }
            if (TypeChar(pwd, minMinus, minMayus, minDigits)) {
                errorTypeChar = "ERROR: invalid password - it must have at least 3 minus, 1 mayus and 2 digits\n";
                console.log(errorTypeChar);
            }
            if (NoRep(pwd)) {
                errorNoRep = "ERROR: invalid password - it can't have the same 3 characters in a row\n";
                console.log(errorNoRep);
            }

            if (!NumChar(pwd, minChar, maxChar) || !TypeChar(pwd, minMinus, minMayus, minDigits) || !NoRep(pwd)) {
                alert("Everithing alright");
            } else{
                alert(errorNumChar + errorTypeChar + errorNoRep)
            }
            
        }
    </script>
</body>
</html>